# frozen_string_literal: false

module Trop
  # OS detection lib
  class OS
    # @return  true/false if 'on windows ?'
    def self.win?
      (/cygwin|mswin|mingw|bccwin|wince|emx/ =~ RUBY_PLATFORM) != nil
    end

    # @return  true/false if 'on mac?'
    def self.mac?
      (/darwin/ =~ RUBY_PLATFORM) != nil
    end

    # @return  true/false if 'on unix?'
    def self.unix?
      !::Trop::OS.win?
    end

    # @return  true/false if 'on tux?'
    def self.linux?
      ::Trop::OS.unix? and not ::Trop::OS.mac?
    end

    # @return  true/false if 'on jruby?'
    def self.jruby?
      (RUBY_ENGINE == 'jruby')
    end
  end
end