IDIR = 'doc/internal/'.freeze
# frozen_string_literal: false

desc 'tad (test and docs)'
task :tad do
  puts 'Working in: ' + Dir.getwd.to_str
  #`cd #{IDIR}; git add *; git commit -m"safe old logs" -a; rm *.log; cd -`
  #`rake routes | tee #{IDIR}routes.log `
  #  `rake initializers | tee #{IDIR}initializers.log`
  `rake notes:rb | tee #{IDIR}notes.todo.log`
  `rake notes:md | tee #{IDIR}notes.md.log`
  `rake notes:all | tee #{IDIR}notes.log`
  #`rake stats | tee #{IDIR}stats.log`
  #`rake test 2>&1 | tee #{IDIR}rake_test.log`
  #`rake spec 2>&1 | tee #{IDIR}rake_spec.log`
  #`git add *; git commit -m"safe old logs" -a`
end

namespace :notes do
  require File.dirname(__FILE__) + '/source_annotation_extractor'

  desc 'Enumerate a custom annotation, specify with ANNOTATION=CUSTOM'
  task :custom do
    SourceAnnotationExtractor.enumerate ENV['ANNOTATION']
  end

  desc 'Enumerate all annotations (use notes:optimize, :fixme, :todo for focus)'
  task :css do
    SourceAnnotationExtractor::Annotation.register_extensions('css', 'scss', 'sass', 'less', 'js') { |tag| %r{\/\/\s*(#{tag}):?\s*(.*)$} }
    SourceAnnotationExtractor.enumerate 'OPTIMIZE|FIXME|TODO', tag: true
    SourceAnnotationExtractor.enumerate 'TODO|LATER', dirs: %w[doc,lib], tag: true
  end
  desc 'Enumerate all markdowns' ## custom annotation, specify with ANNOTATION=CUSTOM
  task :md do
    SourceAnnotationExtractor::Annotation.register_extensions('md') { |tag| /(#{tag}):?\s*(.*)$/ }
    SourceAnnotationExtractor.enumerate 'TODO|LATER|FIXME', dirs: %w(. ../biosonlinux)
    # dirs: ['.','doc','lib','test','artefacts','../biosonlinux'], tag: true
  end
  desc 'Enumerate all rubies' ## custom annotation, specify with ANNOTATION=CUSTOM
  task :rb do
    SourceAnnotationExtractor::Annotation.register_extensions('erb') { |tag| /<%\s*#\s*(#{tag}):?\s*(.*?)\s*%>/ }
    SourceAnnotationExtractor::Annotation.register_extensions('builder', 'rb', 'rake', 'yml', 'yaml', 'ruby') { |tag| /#\s*(#{tag}):?\s*(.*)$/ }
    SourceAnnotationExtractor.enumerate 'OPTIMIZE|FIXME|TODO|LATER', dirs: %w[app/admin app/controllers bin/lib db config test spec .], tag: true
  end
  #
end
